
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;

public class PinoTest {

    Pino pino;

    @Before
    public void setUp() {
        pino = new OmaPino(3);
    }

    @Test
    public void alussaTyhja() {
        assertTrue(pino.tyhja());
    }

    @Test
    public void lisayksenJalkeenEiTyhja() {
        pino.pinoon(5);
        assertFalse(pino.tyhja());
    }

    @Test
    public void lisattyAlkioTuleePinosta() {
        pino.pinoon(3);
        assertEquals(3, pino.pinosta());
    }

    @Test
    public void lisayksenJaPoistonJalkeenPinoOnTaasTyhja() {
        pino.pinoon(3);
        pino.pinosta();
        assertTrue(pino.tyhja());
    }

    @Test
    public void lisatytAlkiotTulevatPinostaOikeassaJarjestyksessa() {
        pino.pinoon(1);
        pino.pinoon(2);
        pino.pinoon(3);

        assertEquals( 3, pino.pinosta() );
        assertEquals( 2, pino.pinosta() );
        assertEquals( 1, pino.pinosta() );
    }

    @Test
    public void tyhjennyksenJalkeenPinoonLaitettuAlkioTuleeUlosPinosta() {
        pino.pinoon(1);
        pino.pinosta();

        pino.pinoon(5);

        assertEquals( 5, pino.pinosta() );
    }

    @Test
    public void alussaPinoEiOleTaysi(){
        assertFalse( pino.taynna() );
    }

    @Test
    public void pinoEiTaytyLiianNopeasti(){
        pino.pinoon(1);
        pino.pinoon(2);
        assertFalse( pino.taynna() );
    }

    @Test
    public void kunPinoTaynnaIlmoitetaanSenOlevanTaysi(){
        pino.pinoon(1);
        pino.pinoon(2);
        pino.pinoon(3);
        assertTrue( pino.taynna() );
    }
}
